# File de priorité

En informatique, une **file de priorité** est un type
de données abstrait qui s'apparente à une file d'attente normale
ou une structure de données empilées, mais où chaque élément est
en plus associé à une "priorité".
Dans une file de priorité, un élément avec une priorité élevée
est servi avant un élément à faible priorité. Si deux éléments ont
la même priorité, ils sont servis selon leur ordre dans la file
d'attente.

Alors que les files de priorité sont souvent implémentées avec des tas,
elles sont conceptuellement distinctes des tas. Une file de priorité
est un concept abstrait comme "une liste" ou "une carte"; tout comme
une liste peut être implémentée avec une liste chaînée ou un tableau,
une file de priorité peut être implémentée avec un tas ou une variété
d'autres méthodes telles qu'un tableau non ordonné.

## Références

- [Wikipedia](https://fr.wikipedia.org/wiki/File_de_priorit%C3%A9)
- [YouTube](https://www.youtube.com/watch?v=wptevk0bshY&list=PLLXdhg_r2hKA7DPDsunoDZ-Z769jWn4R8&index=6)
